# ZeroCostDL4Mic: exploiting Google Colab to develop a free and open-source toolbox for Deep-Learning in microscopy

_**Tl;dr**_: this [**wiki page**][wikiPage] has everything you need to get started.

## What is this?

ZeroCostDL4Mic is a collection of self-explanatory Jupyter Notebooks for [**Google Colab**][1] that features an **easy-to-use graphical user interface**. They are meant to quickly get you started on learning to use deep-learning for microscopy. Google Colab itself **provides the computations resources needed at no-cost**. **ZeroCostDL4Mic** is designed for researchers that have little or no coding expertise to quickly test, train and use popular Deep-Learning networks.

## Want to see a short video demonstration?

| Running a ZeroCostDL4Mic notebook | Example data in ZeroCostDL4Mic | Romain's talk @ Aurox conference | Talk @ SPAOM |
|:-:|:-:|:-:|:-:|
| [![](https://github.com/HenriquesLab/ZeroCostDL4Mic/blob/master/Wiki_files/ZeroCostDL4Mic_SuppVideo1_Running_a_notebook.jpg)](https://youtu.be/TrDuidvO85s) | [![](https://github.com/HenriquesLab/ZeroCostDL4Mic/blob/master/Wiki_files/ZeroCostDL4Mic_SuppVideo2_Analysis_of_example_data.jpg)](https://youtu.be/KauKEr0Kkkc) | [![](https://github.com/HenriquesLab/ZeroCostDL4Mic/blob/master/Wiki_files/ScreenShot_AuroxTalk_resized.jpg)](https://youtu.be/rCEbYOnNJp0) | [![](https://github.com/HenriquesLab/ZeroCostDL4Mic/blob/master/Wiki_files/ZDL4_SPAOM.jpg)](https://www.youtube.com/watch?v=ozffChqtgJw) |

## Who is it for?

Any researcher interested in microscopy, independent of their background training. **ZeroCostDL4Mi**c is designed for anyone with little or no coding expertise to quickly test, train and use popular Deep-Learning networks used to process microscopy data.

## Acknowledgements

This project initiated as a collaboration between the [**Jacquemet**][6] and [**Henriques**][5] laboratories, considerably expanding with the help of laboratories spread across the planet. There is a long list of contributors associated with the project acknowledged in our [**preprint**](https://www.biorxiv.org/content/10.1101/2020.03.20.000133v3) and the [**wiki page**][wikiPageContributors].

## How to cite this work

_Lucas von Chamier,  Romain F. Laine, Johanna Jukkala,  Christoph Spahn, Daniel Krentzel, Elias Nehme,  Martina Lerche, Sara Hernández-pérez,  Pieta Mattila,  Eleni Karinou,  Séamus Holden, Ahmet Can Solak,  Alexander Krull,  Tim-Oliver Buchholz,  Martin L Jones,  Loic Alain Royer,  Christophe Leterrier, Yoav Shechtman,  Florian Jug,  Mike Heilemann,  Guillaume Jacquemet,  Ricardo Henriques. ZeroCostDL4Mic: an open platform to use Deep-Learning in Microscopy. bioRxiv, 2020. DOI: [https://doi.org/10.1101/2020.03.20.000133](https://www.biorxiv.org/content/10.1101/2020.03.20.000133v3)_

[![](https://github.com/HenriquesLab/ZeroCostDL4Mic/blob/master/Wiki_files/preprintScreenshot.png)](https://www.biorxiv.org/content/10.1101/2020.03.20.000133v4)

  [1]: https://colab.research.google.com/notebooks/intro.ipynb
  [2]: https://twitter.com/guijacquemet
  [3]: https://twitter.com/LaineBioImaging
  [4]: https://twitter.com/HenriquesLab
  [5]: https://henriqueslab.github.io/
  [6]: https://cellmig.org/
  [7]: https://github.com/HenriquesLab/ZeroCostDL4Mic/blob/master/Wiki_files/ColabPaperFigure1_v4.png
  [8]: https://github.com/HenriquesLab/ZeroCostDL4Mic/blob/master/Wiki_files/VideoDemoScreenshot1.png
  [wikiPage]: https://github.com/HenriquesLab/DeepLearning_Collab/wiki
  [wikiPageContributors]: https://github.com/HenriquesLab/ZeroCostDL4Mic/wiki#contributors
